/**********************************************************************
 *
 * queryaction.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: queryaction.h 533 1999-09-07 04:57:01Z sjboddie $
 *
 *********************************************************************/


#ifndef QUERYACTION_H
#define QUERYACTION_H

#include "gsdlconf.h"
#include "action.h"


class queryaction : public action {

protected:
  text_t formatstring;
  int num_phrases;

  void define_query_macros (cgiargsclass &args, displayclass &disp, 
			    const FilterResponse_t &response); 

  void set_option_macro (const text_t &macroname, text_t current_value,
			 const FilterOption_t &option, displayclass &disp);


public:
  queryaction ();
  virtual ~queryaction () {}
  
  void configure (const text_t &key, const text_tarray &cfgline);
  bool init (ostream &logout);
  
  text_t get_action_name () {return "q";}
  
  bool check_cgiargs (cgiargsinfoclass &argsinfo, cgiargsclass &args, 
		      ostream &logout);
  void get_cgihead_info (cgiargsclass &args, response_t &response,
			 text_t &response_data, ostream &logout);
  
  void define_internal_macros (const ColInfoResponse_t &collectinfo, displayclass &disp, 
			       cgiargsclass &args, recptproto *collectproto, ostream &logout);
  void define_external_macros (const ColInfoResponse_t &collectinfo, displayclass &disp, 
			       cgiargsclass &args, recptproto *collectproto, ostream &logout);
  
  bool do_action (cgiargsclass &args, const ColInfoResponse_t &collectinfo, 
		  recptproto *collectproto, displayclass &disp, 
		  outconvertclass &outconvert, ostream &textout, 
		  ostream &logout);
};


#endif
